---
title: retrieve-a-list-of-projects
product: vercel
url: /docs/rest-api/projects/retrieve-a-list-of-projects
type: reference
prerequisites:
  []
related:
  - /docs/rest-api
summary: Learn about retrieve-a-list-of-projects on Vercel.
install_vercel_plugin: npx plugins add vercel/vercel-plugin
---

# Retrieve a list of projects

```http
GET /v10/projects
```

Allows to retrieve the list of projects of the authenticated user or team. The list will be paginated and the provided query parameters allow filtering the returned projects.

## Authentication

**bearerToken**: HTTP bearer

## Query parameters

| Name | Type | Required | Description |
|---|---|---|---|
| `from` | string | No | Query only projects updated after the given timestamp or continuation token. |
| `gitForkProtection` | string. enum: 1, 0 | No | Specifies whether PRs from Git forks should require a team member's authorization before it can be deployed |
| `limit` | string | No | Limit the number of projects returned |
| `search` | string. maxLength: 100 | No | Search projects by the name field |
| `repo` | string | No | Filter results by repo. Also used for project count |
| `repoId` | string | No | Filter results by Repository ID. |
| `repoUrl` | string | No | Filter results by Repository URL. |
| `excludeRepos` | string | No | Filter results by excluding those projects that belong to a repo |
| `edgeConfigId` | string | No | Filter results by connected Edge Config ID |
| `edgeConfigTokenId` | string | No | Filter results by connected Edge Config Token ID |
| `deprecated` | boolean | No |  |
| `elasticConcurrencyEnabled` | string. enum: 1, 0 | No | Filter results by projects with elastic concurrency enabled |
| `staticIpsEnabled` | string. enum: 0, 1 | No | Filter results by projects with Static IPs enabled |
| `buildMachineTypes` | string | No | Filter results by build machine types. Accepts comma-separated values. Use \"default\" for projects without a build machine type set. |
| `buildQueueConfiguration` | string. enum: SKIP_NAMESPACE_QUEUE, WAIT_FOR_NAMESPACE_QUEUE | No | Filter results by build queue configuration. SKIP_NAMESPACE_QUEUE includes projects without a configuration set. |
| `teamId` | string | No | The Team identifier to perform the request on behalf of. |
| `slug` | string | No | The Team slug to perform the request on behalf of. |


## Responses

### 200: No description

Content-Type: `application/json`

```json
{
  "nullable": true,
  "oneOf": [
    {
      "type": "array",
      "items": {
        "type": "object",
        "required": [
          "accountId",
          "alias",
          "deploymentExpiration",
          "directoryListing",
          "id",
          "name",
          "nodeVersion",
          "resourceConfig",
          "serverlessFunctionRegion"
        ],
        "properties": {
          "accountId": {
            "type": "string"
          },
          "alias": {
            "type": "array",
            "items": {
              "type": "object",
              "required": [
                "deployment",
                "domain",
                "environment",
                "target"
              ],
              "properties": {
                "configuredBy": {
                  "type": "string",
                  "enum": [
                    "A",
                    "CNAME",
                    "http",
                    "dns-01"
                  ],
                  "nullable": true
                },
                "configuredChangedAt": {
                  "type": "number",
                  "nullable": true
                },
                "createdAt": {
                  "type": "number",
                  "nullable": true
                },
                "deployment": {
                  "type": "object",
                  "nullable": true,
                  "required": [
                    "createdAt",
                    "createdIn",
                    "creator",
                    "deploymentHostname",
                    "id",
                    "name",
                    "plan",
                    "private",
                    "readyState",
                    "type",
                    "url",
                    "userId"
                  ],
                  "properties": {
                    "alias": {
                      "type": "array",
                      "items": {
                        "type": "string"
                      }
                    },
                    "aliasAssigned": {
                      "nullable": true,
                      "oneOf": [
                        {
                          "type": "number"
                        },
                        {
                          "type": "boolean",
                          "enum": [
                            false,
                            true
                          ]
                        }
                      ]
                    },
                    "builds": {
                      "type": "array",
                      "items": {
                        "type": "object",
                        "required": [
                          "use"
                        ],
                        "properties": {
                          "use": {
                            "type": "string"
                          },
                          "src": {
                            "type": "string"
                          },
                          "dest": {
                            "type": "string"
                          }
                        }
                      }
                    },
                    "createdAt": {
                      "type": "number"
                    },
                    "createdIn": {
                      "type": "string"
                    },
                    "creator": {
                      "type": "object",
                      "nullable": true,
                      "required": [
                        "email",
                        "uid",
                        "username"
                      ],
                      "properties": {
                        "email": {
                          "type": "string"
                        },
                        "githubLogin": {
                          "type": "string"
                        },
                        "gitlabLogin": {
                          "type": "string"
                        },
                        "uid": {
                          "type": "string"
                        },
                        "username": {
                          "type": "string"
                        }
                      }
                    },
                    "deploymentHostname": {
                      "type": "string"
                    },
                    "name": {
                      "type": "string"
                    },
                    "forced": {
                      "type": "boolean",
                      "enum": [
                        false,
                        true
                      ]
                    },
                    "id": {
                      "type": "string"
                    },
                    "meta": {
                      "type": "object",
                      "additionalProperties": {
                        "type": "string"
                      }
                    },
                    "plan": {
                      "type": "string"
                    },
                    "private": {
                      "type": "boolean",
                      "enum": [
                        false,
                        true
                      ]
                    },
                    "readyState": {
                      "type": "string"
                    },
                    "requestedAt": {
                      "type": "number"
                    },
                    "target": {
                      "type": "string",
                      "nullable": true
                    },
                    "teamId": {
                      "type": "string",
                      "nullable": true
                    },
                    "type": {
                      "type": "string"
                    },
                    "url": {
                      "type": "string"
                    },
                    "userId": {
                      "type": "string"
                    },
                    "withCache": {
                      "type": "boolean",
                      "enum": [
                        false,
                        true
                      ]
                    }
                  }
                },
                "domain": {
                  "type": "string"
                },
                "environment": {
                  "type": "string",
                  "enum": [
                    "production",
                    "preview"
                  ]
                },
                "gitBranch": {
                  "type": "string",
                  "nullable": true
                },
                "redirect": {
                  "type": "string",
                  "nullable": true
                },
                "redirectStatusCode": {
                  "type": "number",
                  "enum": [
                    301,
                    302,
                    307,
                    308
                  ],
                  "nullable": true
                },
                "target": {
                  "type": "string",
                  "enum": [
                    "PRODUCTION",
                    "STAGING",
                    "PREVIEW"
                  ]
                }
              }
            }
          },
          "analytics": {
            "type": "object",
            "required": [
              "disabledAt",
              "enabledAt",
              "id"
            ],
            "properties": {
              "id": {
                "type": "string"
              },
              "canceledAt": {
                "type": "number",
                "nullable": true
              },
              "disabledAt": {
                "type": "number"
              },
              "enabledAt": {
                "type": "number"
              },
              "paidAt": {
                "type": "number"
              },
              "sampleRatePercent": {
                "type": "number",
                "nullable": true
              },
              "spendLimitInDollars": {
                "type": "number",
                "nullable": true
              }
            }
          },
          "appliedCve55182Migration": {
            "type": "boolean",
            "enum": [
              false,
              true
            ]
          },
          "autoExposeSystemEnvs": {
            "type": "boolean",
            "enum": [
              false,
              true
            ]
          },
          "autoAssignCustomDomains": {
            "type": "boolean",
            "enum": [
              false,
              true
            ]
          },
          "autoAssignCustomDomainsUpdatedBy": {
            "type": "string"
          },
          "buildCommand": {
            "type": "string",
            "nullable": true
          },
          "commandForIgnoringBuildStep": {
            "type": "string",
            "nullable": true
          },
          "customerSupportCodeVisibility": {
            "type": "boolean",
            "enum": [
              false,
              true
            ]
          },
          "createdAt": {
            "type": "number"
          },
          "devCommand": {
            "type": "string",
            "nullable": true
          },
          "directoryListing": {
            "type": "boolean",
            "enum": [
              false,
              true
            ]
          },
          "deploymentExpiration": {
            "type": "object",
            "description": "Retention policies for deployments. These are enforced at the project level, but we also maintain an instance of this at the team level as a default policy that gets applied to new projects.",
            "properties": {
              "expirationDays": {
                "type": "number",
                "description": "Number of days to keep non-production deployments (mostly preview deployments) before soft deletion."
              },
              "expirationDaysProduction": {
                "type": "number",
                "description": "Number of days to keep production deployments before soft deletion."
              },
              "expirationDaysCanceled": {
                "type": "number",
                "description": "Number of days to keep canceled deployments before soft deletion."
              },
              "expirationDaysErrored": {
                "type": "number",
                "description": "Number of days to keep errored deployments before soft deletion."
              },
              "deploymentsToKeep": {
                "type": "number",
                "description": "Minimum number of production deployments to keep for this project, even if they are over the production expiration limit."
              }
            }
          },
          "installCommand": {
            "type": "string",
            "nullable": true
          },
          "ipBuckets": {
            "type": "array",
            "items": {
              "type": "object",
              "required": [
                "bucket"
              ],
              "properties": {
                "bucket": {
                  "type": "string"
                },
                "supportUntil": {
                  "type": "number"
                }
              }
            }
          },
          "env": {
            "type": "array",
            "items": {
              "type": "object",
              "required": [
                "key",
                "type",
                "value"
              ],
              "properties": {
                "target": {
                  "oneOf": [
                    {
                      "type": "array",
                      "items": {
                        "type": "string",
                        "enum": [
                          "production",
                          "preview",
                          "development",
                          "preview",
                          "development"
                        ]
                      }
                    },
                    {
                      "type": "string",
                      "enum": [
                        "production",
                        "preview",
                        "development",
                        "preview",
                        "development"
                      ]
                    }
                  ]
                },
                "type": {
                  "type": "string",
                  "enum": [
                    "secret",
                    "system",
                    "encrypted",
                    "plain",
                    "sensitive"
                  ]
                },
                "sunsetSecretId": {
                  "type": "string",
                  "description": "This is used to identify variables that have been migrated from type secret to sensitive."
                },
                "legacyValue": {
                  "type": "string",
                  "description": "Legacy now-encryption ciphertext, present after migration swaps value/vsmValue"
                },
                "decrypted": {
                  "type": "boolean",
                  "enum": [
                    false,
                    true
                  ]
                },
                "value": {
                  "type": "string"
                },
                "vsmValue": {
                  "type": "string"
                },
                "id": {
                  "type": "string"
                },
                "key": {
                  "type": "string"
                },
                "configurationId": {
                  "type": "string",
                  "nullable": true
                },
                "createdAt": {
                  "type": "number"
                },
                "updatedAt": {
                  "type": "number"
                },
                "createdBy": {
                  "type": "string",
                  "nullable": true
                },
                "updatedBy": {
                  "type": "string",
                  "nullable": true
                },
                "gitBranch": {
                  "type": "string"
                },
                "edgeConfigId": {
                  "type": "string",
                  "nullable": true
                },
                "edgeConfigTokenId": {
                  "type": "string",
                  "nullable": true
                },
                "contentHint": {
                  "nullable": true,
                  "oneOf": [
                    {
                      "type": "object",
                      "required": [
                        "storeId",
                        "type"
                      ],
                      "properties": {
                        "type": {
                          "type": "string",
                          "enum": [
                            "redis-url"
                          ]
                        },
                        "storeId": {
                          "type": "string"
                        }
                      }
                    },
                    {
                      "type": "object",
                      "required": [
                        "storeId",
                        "type"
                      ],
                      "properties": {
                        "type": {
                          "type": "string",
                          "enum": [
                            "redis-rest-api-url"
                          ]
                        },
                        "storeId": {
                          "type": "string"
                        }
                      }
                    },
                    {
                      "type": "object",
                      "required": [
                        "storeId",
                        "type"
                      ],
                      "properties": {
                        "type": {
                          "type": "string",
                          "enum": [
                            "redis-rest-api-token"
                          ]
                        },
                        "storeId": {
                          "type": "string"
                        }
                      }
                    },
                    {
                      "type": "object",
                      "required": [
                        "storeId",
                        "type"
                      ],
                      "properties": {
                        "type": {
                          "type": "string",
                          "enum": [
                            "redis-rest-api-read-only-token"
                          ]
                        },
                        "storeId": {
                          "type": "string"
                        }
                      }
                    },
                    {
                      "type": "object",
                      "required": [
                        "storeId",
                        "type"
                      ],
                      "properties": {
                        "type": {
                          "type": "string",
                          "enum": [
                            "blob-read-write-token"
                          ]
                        },
                        "storeId": {
                          "type": "string"
                        }
                      }
                    },
                    {
                      "type": "object",
                      "required": [
                        "storeId",
                        "type"
                      ],
                      "properties": {
                        "type": {
                          "type": "string",
                          "enum": [
                            "postgres-url"
                          ]
                        },
                        "storeId": {
                          "type": "string"
                        }
                      }
                    },
                    {
                      "type": "object",
                      "required": [
                        "storeId",
                        "type"
                      ],
                      "properties": {
                        "type": {
                          "type": "string",
                          "enum": [
                            "postgres-url-non-pooling"
                          ]
                        },
                        "storeId": {
                          "type": "string"
                        }
                      }
                    },
                    {
                      "type": "object",
                      "required": [
                        "storeId",
                        "type"
                      ],
                      "properties": {
                        "type": {
                          "type": "string",
                          "enum": [
                            "postgres-prisma-url"
                          ]
                        },
                        "storeId": {
                          "type": "string"
                        }
                      }
                    },
                    {
                      "type": "object",
                      "required": [
                        "storeId",
                        "type"
                      ],
                      "properties": {
                        "type": {
                          "type": "string",
                          "enum": [
                            "postgres-user"
                          ]
                        },
                        "storeId": {
                          "type": "string"
                        }
                      }
                    },
                    {
                      "type": "object",
                      "required": [
                        "storeId",
                        "type"
                      ],
                      "properties": {
                        "type": {
                          "type": "string",
                          "enum": [
                            "postgres-host"
                          ]
                        },
                        "storeId": {
                          "type": "string"
                        }
                      }
                    },
                    {
                      "type": "object",
                      "required": [
                        "storeId",
                        "type"
                      ],
                      "properties": {
                        "type": {
                          "type": "string",
                          "enum": [
                            "postgres-password"
                          ]
                        },
                        "storeId": {
                          "type": "string"
                        }
                      }
                    },
                    {
                      "type": "object",
                      "required": [
                        "storeId",
                        "type"
                      ],
                      "properties": {
                        "type": {
                          "type": "string",
                          "enum": [
                            "postgres-database"
                          ]
                        },
                        "storeId": {
                          "type": "string"
                        }
                      }
                    },
                    {
                      "type": "object",
                      "required": [
                        "storeId",
                        "type"
                      ],
                      "properties": {
                        "type": {
                          "type": "string",
                          "enum": [
                            "postgres-url-no-ssl"
                          ]
                        },
                        "storeId": {
                          "type": "string"
                        }
                      }
                    },
                    {
                      "type": "object",
                      "required": [
                        "integrationConfigurationId",
                        "integrationId",
                        "integrationProductId",
                        "storeId",
                        "type"
                      ],
                      "properties": {
                        "type": {
                          "type": "string",
                          "enum": [
                            "integration-store-secret"
                          ]
                        },
                        "storeId": {
                          "type": "string"
                        },
                        "integrationId": {
                          "type": "string"
                        },
                        "integrationProductId": {
                          "type": "string"
                        },
                        "integrationConfigurationId": {
                          "type": "string"
                        }
                      }
                    },
                    {
                      "type": "object",
                      "required": [
                        "projectId",
                        "type"
                      ],
                      "properties": {
                        "type": {
                          "type": "string",
                          "enum": [
                            "flags-connection-string"
                          ]
                        },
                        "projectId": {
                          "type": "string"
                        }
                      }
                    }
                  ]
                },
                "internalContentHint": {
                  "type": "object",
                  "description": "Similar to `contentHints`, but should not be exposed to the user.",
                  "nullable": true,
                  "required": [
                    "encryptedValue",
                    "type"
                  ],
                  "properties": {
                    "type": {
                      "type": "string",
                      "enum": [
                        "flags-secret"
                      ]
                    },
                    "encryptedValue": {
                      "type": "string",
                      "description": "Contains the `value` of the env variable, encrypted with a special key to make decryption possible in the subscriber Lambda."
                    }
                  }
                },
                "comment": {
                  "type": "string"
                },
                "customEnvironmentIds": {
                  "type": "array",
                  "items": {
                    "type": "string"
                  }
                }
              }
            }
          },
          "framework": {
            "type": "string",
            "enum": [
              "services",
              "blitzjs",
              "nextjs",
              "gatsby",
              "remix",
              "react-router",
              "astro",
              "hexo",
              "eleventy",
              "docusaurus-2",
              "docusaurus",
              "preact",
              "solidstart-1",
              "solidstart",
              "dojo",
              "ember",
              "vue",
              "scully",
              "ionic-angular",
              "angular",
              "polymer",
              "svelte",
              "sveltekit",
              "sveltekit-1",
              "ionic-react",
              "create-react-app",
              "gridsome",
              "umijs",
              "sapper",
              "saber",
              "stencil",
              "nuxtjs",
              "redwoodjs",
              "hugo",
              "jekyll",
              "brunch",
              "middleman",
              "zola",
              "hydrogen",
              "vite",
              "tanstack-start",
              "vitepress",
              "vuepress",
              "parcel",
              "fastapi",
              "flask",
              "fasthtml",
              "django",
              "sanity-v3",
              "sanity",
              "storybook",
              "nitro",
              "hono",
              "express",
              "h3",
              "koa",
              "nestjs",
              "elysia",
              "fastify",
              "xmcp",
              "python",
              "ruby",
              "rust",
              "node",
              "go"
            ],
            "nullable": true
          },
          "gitForkProtection": {
            "type": "boolean",
            "enum": [
              false,
              true
            ]
          },
          "id": {
            "type": "string"
          },
          "latestDeployments": {
            "type": "array",
            "items": {
              "type": "object",
              "required": [
                "createdAt",
                "createdIn",
                "creator",
                "deploymentHostname",
                "id",
                "name",
                "plan",
                "private",
                "readyState",
                "type",
                "url",
                "userId"
              ],
              "properties": {
                "alias": {
                  "type": "array",
                  "items": {
                    "type": "string"
                  }
                },
                "aliasAssigned": {
                  "nullable": true,
                  "oneOf": [
                    {
                      "type": "number"
                    },
                    {
                      "type": "boolean",
                      "enum": [
                        false,
                        true
                      ]
                    }
                  ]
                },
                "builds": {
                  "type": "array",
                  "items": {
                    "type": "object",
                    "required": [
                      "use"
                    ],
                    "properties": {
                      "use": {
                        "type": "string"
                      },
                      "src": {
                        "type": "string"
                      },
                      "dest": {
                        "type": "string"
                      }
                    }
                  }
                },
                "createdAt": {
                  "type": "number"
                },
                "createdIn": {
                  "type": "string"
                },
                "creator": {
                  "type": "object",
                  "nullable": true,
                  "required": [
                    "email",
                    "uid",
                    "username"
                  ],
                  "properties": {
                    "email": {
                      "type": "string"
                    },
                    "githubLogin": {
                      "type": "string"
                    },
                    "gitlabLogin": {
                      "type": "string"
                    },
                    "uid": {
                      "type": "string"
                    },
                    "username": {
                      "type": "string"
                    }
                  }
                },
                "deploymentHostname": {
                  "type": "string"
                },
                "name": {
                  "type": "string"
                },
                "forced": {
                  "type": "boolean",
                  "enum": [
                    false,
                    true
                  ]
                },
                "id": {
                  "type": "string"
                },
                "meta": {
                  "type": "object",
                  "additionalProperties": {
                    "type": "string"
                  }
                },
                "plan": {
                  "type": "string"
                },
                "private": {
                  "type": "boolean",
                  "enum": [
                    false,
                    true
                  ]
                },
                "readyState": {
                  "type": "string"
                },
                "requestedAt": {
                  "type": "number"
                },
                "target": {
                  "type": "string",
                  "nullable": true
                },
                "teamId": {
                  "type": "string",
                  "nullable": true
                },
                "type": {
                  "type": "string"
                },
                "url": {
                  "type": "string"
                },
                "userId": {
                  "type": "string"
                },
                "withCache": {
                  "type": "boolean",
                  "enum": [
                    false,
                    true
                  ]
                }
              }
            }
          },
          "link": {
            "oneOf": [
              {
                "type": "object",
                "required": [
                  "deployHooks",
                  "gitCredentialId",
                  "org",
                  "productionBranch",
                  "type"
                ],
                "properties": {
                  "org": {
                    "type": "string"
                  },
                  "repoOwnerId": {
                    "type": "number",
                    "description": "A new field, should be included in all new project links, is being added just in time when a deployment is created. This is needed for Protected Git scopes."
                  },
                  "repo": {
                    "type": "string"
                  },
                  "repoId": {
                    "type": "number"
                  },
                  "type": {
                    "type": "string",
                    "enum": [
                      "github"
                    ]
                  },
                  "createdAt": {
                    "type": "number"
                  },
                  "deployHooks": {
                    "type": "array",
                    "items": {
                      "type": "object",
                      "required": [
                        "id",
                        "name",
                        "ref",
                        "url"
                      ],
                      "properties": {
                        "createdAt": {
                          "type": "number"
                        },
                        "id": {
                          "type": "string"
                        },
                        "name": {
                          "type": "string"
                        },
                        "ref": {
                          "type": "string"
                        },
                        "url": {
                          "type": "string"
                        }
                      }
                    }
                  },
                  "gitCredentialId": {
                    "type": "string"
                  },
                  "updatedAt": {
                    "type": "number"
                  },
                  "sourceless": {
                    "type": "boolean",
                    "enum": [
                      false,
                      true
                    ]
                  },
                  "productionBranch": {
                    "type": "string"
                  }
                }
              },
              {
                "type": "object",
                "required": [
                  "deployHooks",
                  "gitCredentialId",
                  "org",
                  "productionBranch",
                  "type"
                ],
                "properties": {
                  "type": {
                    "type": "string",
                    "enum": [
                      "github-limited"
                    ]
                  },
                  "repo": {
                    "type": "string"
                  },
                  "repoId": {
                    "type": "number"
                  },
                  "createdAt": {
                    "type": "number"
                  },
                  "updatedAt": {
                    "type": "number"
                  },
                  "org": {
                    "type": "string"
                  },
                  "repoOwnerId": {
                    "type": "number",
                    "description": "A new field, should be included in all new project links, is being added just in time when a deployment is created. This is needed for Protected Git scopes."
                  },
                  "deployHooks": {
                    "type": "array",
                    "items": {
                      "type": "object",
                      "required": [
                        "id",
                        "name",
                        "ref",
                        "url"
                      ],
                      "properties": {
                        "createdAt": {
                          "type": "number"
                        },
                        "id": {
                          "type": "string"
                        },
                        "name": {
                          "type": "string"
                        },
                        "ref": {
                          "type": "string"
                        },
                        "url": {
                          "type": "string"
                        }
                      }
                    }
                  },
                  "gitCredentialId": {
                    "type": "string"
                  },
                  "sourceless": {
                    "type": "boolean",
                    "enum": [
                      false,
                      true
                    ]
                  },
                  "productionBranch": {
                    "type": "string"
                  }
                }
              },
              {
                "type": "object",
                "required": [
                  "deployHooks",
                  "gitCredentialId",
                  "host",
                  "org",
                  "productionBranch",
                  "type"
                ],
                "properties": {
                  "org": {
                    "type": "string"
                  },
                  "repoOwnerId": {
                    "type": "number",
                    "description": "A new field, should be included in all new project links, is being added just in time when a deployment is created. This is needed for Protected Git scopes."
                  },
                  "repo": {
                    "type": "string"
                  },
                  "repoId": {
                    "type": "number"
                  },
                  "type": {
                    "type": "string",
                    "enum": [
                      "github-custom-host"
                    ]
                  },
                  "host": {
                    "type": "string"
                  },
                  "createdAt": {
                    "type": "number"
                  },
                  "deployHooks": {
                    "type": "array",
                    "items": {
                      "type": "object",
                      "required": [
                        "id",
                        "name",
                        "ref",
                        "url"
                      ],
                      "properties": {
                        "createdAt": {
                          "type": "number"
                        },
                        "id": {
                          "type": "string"
                        },
                        "name": {
                          "type": "string"
                        },
                        "ref": {
                          "type": "string"
                        },
                        "url": {
                          "type": "string"
                        }
                      }
                    }
                  },
                  "gitCredentialId": {
                    "type": "string"
                  },
                  "updatedAt": {
                    "type": "number"
                  },
                  "sourceless": {
                    "type": "boolean",
                    "enum": [
                      false,
                      true
                    ]
                  },
                  "productionBranch": {
                    "type": "string"
                  }
                }
              },
              {
                "type": "object",
                "required": [
                  "deployHooks",
                  "gitCredentialId",
                  "productionBranch",
                  "projectId",
                  "projectName",
                  "projectNameWithNamespace",
                  "projectNamespace",
                  "projectUrl",
                  "type"
                ],
                "properties": {
                  "projectId": {
                    "type": "string"
                  },
                  "projectName": {
                    "type": "string"
                  },
                  "projectNameWithNamespace": {
                    "type": "string"
                  },
                  "projectNamespace": {
                    "type": "string"
                  },
                  "projectOwnerId": {
                    "type": "number",
                    "description": "A new field, should be included in all new project links, is being added just in time when a deployment is created. This is needed for Protected Git scopes. This is the id of the top level group that a namespace belongs to. Gitlab supports group nesting (up to 20 levels)."
                  },
                  "projectUrl": {
                    "type": "string"
                  },
                  "type": {
                    "type": "string",
                    "enum": [
                      "gitlab"
                    ]
                  },
                  "createdAt": {
                    "type": "number"
                  },
                  "deployHooks": {
                    "type": "array",
                    "items": {
                      "type": "object",
                      "required": [
                        "id",
                        "name",
                        "ref",
                        "url"
                      ],
                      "properties": {
                        "createdAt": {
                          "type": "number"
                        },
                        "id": {
                          "type": "string"
                        },
                        "name": {
                          "type": "string"
                        },
                        "ref": {
                          "type": "string"
                        },
                        "url": {
                          "type": "string"
                        }
                      }
                    }
                  },
                  "gitCredentialId": {
                    "type": "string"
                  },
                  "updatedAt": {
                    "type": "number"
                  },
                  "sourceless": {
                    "type": "boolean",
                    "enum": [
                      false,
                      true
                    ]
                  },
                  "productionBranch": {
                    "type": "string"
                  }
                }
              },
              {
                "type": "object",
                "required": [
                  "deployHooks",
                  "gitCredentialId",
                  "name",
                  "owner",
                  "productionBranch",
                  "slug",
                  "type",
                  "uuid",
                  "workspaceUuid"
                ],
                "properties": {
                  "name": {
                    "type": "string"
                  },
                  "slug": {
                    "type": "string"
                  },
                  "owner": {
                    "type": "string"
                  },
                  "type": {
                    "type": "string",
                    "enum": [
                      "bitbucket"
                    ]
                  },
                  "uuid": {
                    "type": "string"
                  },
                  "workspaceUuid": {
                    "type": "string"
                  },
                  "createdAt": {
                    "type": "number"
                  },
                  "deployHooks": {
                    "type": "array",
                    "items": {
                      "type": "object",
                      "required": [
                        "id",
                        "name",
                        "ref",
                        "url"
                      ],
                      "properties": {
                        "createdAt": {
                          "type": "number"
                        },
                        "id": {
                          "type": "string"
                        },
                        "name": {
                          "type": "string"
                        },
                        "ref": {
                          "type": "string"
                        },
                        "url": {
                          "type": "string"
                        }
                      }
                    }
                  },
                  "gitCredentialId": {
                    "type": "string"
                  },
                  "updatedAt": {
                    "type": "number"
                  },
                  "sourceless": {
                    "type": "boolean",
                    "enum": [
                      false,
                      true
                    ]
                  },
                  "productionBranch": {
                    "type": "string"
                  }
                }
              },
              {
                "type": "object",
                "required": [
                  "deployHooks",
                  "gitCredentialId",
                  "org",
                  "productionBranch",
                  "repo",
                  "type"
                ],
                "properties": {
                  "org": {
                    "type": "string"
                  },
                  "repo": {
                    "type": "string"
                  },
                  "type": {
                    "type": "string",
                    "enum": [
                      "vercel"
                    ]
                  },
                  "createdAt": {
                    "type": "number"
                  },
                  "deployHooks": {
                    "type": "array",
                    "items": {
                      "type": "object",
                      "required": [
                        "id",
                        "name",
                        "ref",
                        "url"
                      ],
                      "properties": {
                        "createdAt": {
                          "type": "number"
                        },
                        "id": {
                          "type": "string"
                        },
                        "name": {
                          "type": "string"
                        },
                        "ref": {
                          "type": "string"
                        },
                        "url": {
                          "type": "string"
                        }
                      }
                    }
                  },
                  "gitCredentialId": {
                    "type": "string"
                  },
                  "updatedAt": {
                    "type": "number"
                  },
                  "sourceless": {
                    "type": "boolean",
                    "enum": [
                      false,
                      true
                    ]
                  },
                  "productionBranch": {
                    "type": "string"
                  }
                }
              }
            ]
          },
          "name": {
            "type": "string"
          },
          "nodeVersion": {
            "type": "string",
            "enum": [
              "24.x",
              "22.x",
              "20.x",
              "18.x",
              "16.x",
              "14.x",
              "12.x",
              "10.x",
              "8.10.x"
            ]
          },
          "outputDirectory": {
            "type": "string",
            "nullable": true
          },
          "passwordProtection": {
            "type": "object",
            "nullable": true
          },
          "publicSource": {
            "type": "boolean",
            "enum": [
              false,
              true
            ],
            "nullable": true
          },
          "resourceConfig": {
            "type": "object",
            "required": [
              "functionDefaultRegions"
            ],
            "properties": {
              "elasticConcurrencyEnabled": {
                "type": "boolean",
                "enum": [
                  false,
                  true
                ]
              },
              "fluid": {
                "type": "boolean",
                "enum": [
                  false,
                  true
                ]
              },
              "functionDefaultRegions": {
                "type": "array",
                "items": {
                  "type": "string"
                }
              },
              "functionDefaultTimeout": {
                "type": "number"
              },
              "functionDefaultMemoryType": {
                "type": "string",
                "enum": [
                  "standard_legacy",
                  "standard",
                  "performance"
                ]
              },
              "functionZeroConfigFailover": {
                "type": "boolean",
                "enum": [
                  false,
                  true
                ]
              },
              "buildMachineType": {
                "type": "string",
                "enum": [
                  "standard",
                  "enhanced",
                  "turbo"
                ]
              },
              "buildMachineSelection": {
                "type": "string",
                "enum": [
                  "fixed",
                  "elastic"
                ]
              },
              "buildMachineElasticLastUpdated": {
                "type": "number"
              },
              "isNSNBDisabled": {
                "type": "boolean",
                "enum": [
                  false,
                  true
                ]
              },
              "buildQueue": {
                "type": "object",
                "properties": {
                  "configuration": {
                    "type": "string",
                    "enum": [
                      "SKIP_NAMESPACE_QUEUE",
                      "WAIT_FOR_NAMESPACE_QUEUE"
                    ]
                  }
                }
              }
            }
          },
          "rollingRelease": {
            "type": "object",
            "description": "Project-level rolling release configuration that defines how deployments should be gradually rolled out",
            "nullable": true,
            "required": [
              "target"
            ],
            "properties": {
              "target": {
                "type": "string",
                "description": "The environment that the release targets, currently only supports production. Adding in case we want to configure with alias groups or custom environments."
              },
              "stages": {
                "type": "array",
                "description": "An array of all the stages required during a deployment release. Each stage defines a target percentage and advancement rules. The final stage must always have targetPercentage: 100.",
                "nullable": true,
                "items": {
                  "type": "object",
                  "description": "An array of all the stages required during a deployment release. Each stage defines a target percentage and advancement rules. The final stage must always have targetPercentage: 100.",
                  "required": [
                    "targetPercentage"
                  ],
                  "properties": {
                    "targetPercentage": {
                      "type": "number",
                      "description": "The percentage of traffic to serve to the canary deployment (0-100)"
                    },
                    "requireApproval": {
                      "type": "boolean",
                      "description": "Whether or not this stage requires manual approval to proceed",
                      "enum": [
                        false,
                        true
                      ]
                    },
                    "duration": {
                      "type": "number",
                      "description": "Duration in minutes for automatic advancement to the next stage"
                    },
                    "linearShift": {
                      "type": "boolean",
                      "description": "Whether to linearly shift traffic over the duration of this stage",
                      "enum": [
                        false,
                        true
                      ]
                    }
                  }
                }
              },
              "canaryResponseHeader": {
                "type": "boolean",
                "description": "Whether the request served by a canary deployment should return a header indicating a canary was served. Defaults to `false` when omitted.",
                "enum": [
                  false,
                  true
                ]
              }
            }
          },
          "rootDirectory": {
            "type": "string",
            "nullable": true
          },
          "serverlessFunctionRegion": {
            "type": "string"
          },
          "serverlessFunctionZeroConfigFailover": {
            "type": "boolean",
            "enum": [
              false,
              true
            ]
          },
          "speedInsights": {
            "type": "object",
            "required": [
              "id"
            ],
            "properties": {
              "id": {
                "type": "string"
              },
              "enabledAt": {
                "type": "number"
              },
              "disabledAt": {
                "type": "number"
              },
              "canceledAt": {
                "type": "number"
              },
              "hasData": {
                "type": "boolean",
                "enum": [
                  false,
                  true
                ]
              },
              "paidAt": {
                "type": "number"
              }
            }
          },
          "skipGitConnectDuringLink": {
            "type": "boolean",
            "enum": [
              false,
              true
            ]
          },
          "sourceFilesOutsideRootDirectory": {
            "type": "boolean",
            "enum": [
              false,
              true
            ]
          },
          "ssoProtection": {
            "type": "object",
            "nullable": true,
            "required": [
              "deploymentType"
            ],
            "properties": {
              "deploymentType": {
                "type": "string",
                "enum": [
                  "preview",
                  "all",
                  "prod_deployment_urls_and_all_previews",
                  "all_except_custom_domains"
                ]
              },
              "cve55182MigrationAppliedFrom": {
                "type": "string",
                "enum": [
                  "preview",
                  "all",
                  "prod_deployment_urls_and_all_previews",
                  "all_except_custom_domains"
                ],
                "nullable": true
              }
            }
          },
          "targets": {
            "type": "object",
            "additionalProperties": {
              "type": "object",
              "nullable": true,
              "required": [
                "createdAt",
                "createdIn",
                "creator",
                "deploymentHostname",
                "id",
                "name",
                "plan",
                "private",
                "readyState",
                "type",
                "url",
                "userId"
              ],
              "properties": {
                "alias": {
                  "type": "array",
                  "items": {
                    "type": "string"
                  }
                },
                "aliasAssigned": {
                  "nullable": true,
                  "oneOf": [
                    {
                      "type": "number"
                    },
                    {
                      "type": "boolean",
                      "enum": [
                        false,
                        true
                      ]
                    }
                  ]
                },
                "builds": {
                  "type": "array",
                  "items": {
                    "type": "object",
                    "required": [
                      "use"
                    ],
                    "properties": {
                      "use": {
                        "type": "string"
                      },
                      "src": {
                        "type": "string"
                      },
                      "dest": {
                        "type": "string"
                      }
                    }
                  }
                },
                "createdAt": {
                  "type": "number"
                },
                "createdIn": {
                  "type": "string"
                },
                "creator": {
                  "type": "object",
                  "nullable": true,
                  "required": [
                    "email",
                    "uid",
                    "username"
                  ],
                  "properties": {
                    "email": {
                      "type": "string"
                    },
                    "githubLogin": {
                      "type": "string"
                    },
                    "gitlabLogin": {
                      "type": "string"
                    },
                    "uid": {
                      "type": "string"
                    },
                    "username": {
                      "type": "string"
                    }
                  }
                },
                "deploymentHostname": {
                  "type": "string"
                },
                "name": {
                  "type": "string"
                },
                "forced": {
                  "type": "boolean",
                  "enum": [
                    false,
                    true
                  ]
                },
                "id": {
                  "type": "string"
                },
                "meta": {
                  "type": "object",
                  "additionalProperties": {
                    "type": "string"
                  }
                },
                "plan": {
                  "type": "string"
                },
                "private": {
                  "type": "boolean",
                  "enum": [
                    false,
                    true
                  ]
                },
                "readyState": {
                  "type": "string"
                },
                "requestedAt": {
                  "type": "number"
                },
                "target": {
                  "type": "string",
                  "nullable": true
                },
                "teamId": {
                  "type": "string",
                  "nullable": true
                },
                "type": {
                  "type": "string"
                },
                "url": {
                  "type": "string"
                },
                "userId": {
                  "type": "string"
                },
                "withCache": {
                  "type": "boolean",
                  "enum": [
                    false,
                    true
                  ]
                }
              }
            }
          },
          "transferCompletedAt": {
            "type": "number"
          },
          "transferStartedAt": {
            "type": "number"
          },
          "transferToAccountId": {
            "type": "string"
          },
          "transferredFromAccountId": {
            "type": "string"
          },
          "updatedAt": {
            "type": "number"
          },
          "live": {
            "type": "boolean",
            "enum": [
              false,
              true
            ]
          },
          "hasActiveBranches": {
            "type": "boolean",
            "enum": [
              false,
              true
            ]
          },
          "gitComments": {
            "type": "object",
            "required": [
              "onCommit",
              "onPullRequest"
            ],
            "properties": {
              "onPullRequest": {
                "type": "boolean",
                "description": "Whether the Vercel bot should comment on PRs",
                "enum": [
                  false,
                  true
                ]
              },
              "onCommit": {
                "type": "boolean",
                "description": "Whether the Vercel bot should comment on commits",
                "enum": [
                  false,
                  true
                ]
              }
            }
          },
          "gitProviderOptions": {
            "type": "object",
            "required": [
              "createDeployments"
            ],
            "properties": {
              "createDeployments": {
                "type": "string",
                "description": "Whether the Vercel bot should automatically create GitHub deployments https://docs.github.com/en/rest/deployments/deployments#about-deployments NOTE: repository-dispatch events should be used instead",
                "enum": [
                  "enabled",
                  "disabled"
                ]
              },
              "disableRepositoryDispatchEvents": {
                "type": "boolean",
                "description": "Whether the Vercel bot should not automatically create GitHub repository-dispatch events on deployment events. https://vercel.com/docs/git/vercel-for-github#repository-dispatch-events",
                "enum": [
                  false,
                  true
                ]
              },
              "requireVerifiedCommits": {
                "type": "boolean",
                "description": "Whether the project requires commits to be signed before deployments will be created.",
                "enum": [
                  false,
                  true
                ]
              },
              "consolidatedGitCommitStatus": {
                "type": "object",
                "description": "Configuration for consolidated git commit status reporting. When enabled, Vercel will post a single consolidated commit status instead of individual statuses for each deployment.",
                "required": [
                  "enabled",
                  "propagateFailures"
                ],
                "properties": {
                  "enabled": {
                    "type": "boolean",
                    "description": "Whether consolidated commit status is enabled.",
                    "enum": [
                      false,
                      true
                    ]
                  },
                  "propagateFailures": {
                    "type": "boolean",
                    "description": "Whether to propagate individual deployment failures to the consolidated status.",
                    "enum": [
                      false,
                      true
                    ]
                  }
                }
              }
            }
          },
          "paused": {
            "type": "boolean",
            "enum": [
              false,
              true
            ]
          },
          "webAnalytics": {
            "type": "object",
            "required": [
              "id"
            ],
            "properties": {
              "id": {
                "type": "string"
              },
              "disabledAt": {
                "type": "number"
              },
              "canceledAt": {
                "type": "number"
              },
              "enabledAt": {
                "type": "number"
              },
              "hasData": {
                "type": "boolean",
                "enum": [
                  true
                ]
              }
            }
          },
          "security": {
            "type": "object",
            "properties": {
              "attackModeEnabled": {
                "type": "boolean",
                "enum": [
                  false,
                  true
                ]
              },
              "attackModeUpdatedAt": {
                "type": "number"
              },
              "firewallEnabled": {
                "type": "boolean",
                "enum": [
                  false,
                  true
                ]
              },
              "firewallUpdatedAt": {
                "type": "number"
              },
              "attackModeActiveUntil": {
                "type": "number",
                "nullable": true
              },
              "firewallConfigVersion": {
                "type": "number"
              },
              "firewallRoutes": {
                "type": "array",
                "items": {
                  "type": "object",
                  "properties": {
                    "src": {
                      "oneOf": [
                        {
                          "type": "string"
                        },
                        {
                          "type": "object",
                          "properties": {
                            "re": {
                              "type": "string"
                            },
                            "eq": {
                              "type": "string"
                            },
                            "neq": {
                              "type": "string"
                            },
                            "inc": {
                              "type": "array",
                              "items": {
                                "type": "string"
                              }
                            },
                            "ninc": {
                              "type": "array",
                              "items": {
                                "type": "string"
                              }
                            },
                            "pre": {
                              "type": "string"
                            },
                            "suf": {
                              "type": "string"
                            },
                            "gt": {
                              "type": "number"
                            },
                            "gte": {
                              "type": "number"
                            },
                            "lt": {
                              "type": "number"
                            },
                            "lte": {
                              "type": "number"
                            }
                          }
                        }
                      ]
                    },
                    "has": {
                      "type": "array",
                      "items": {
                        "type": "object",
                        "required": [
                          "type"
                        ],
                        "properties": {
                          "type": {
                            "type": "string",
                            "enum": [
                              "path",
                              "query",
                              "host",
                              "method",
                              "header",
                              "cookie",
                              "ip_address",
                              "protocol",
                              "scheme",
                              "environment",
                              "region",
                              "initial_request_path"
                            ]
                          },
                          "key": {
                            "type": "string"
                          },
                          "value": {
                            "oneOf": [
                              {
                                "type": "string"
                              },
                              {
                                "type": "object",
                                "properties": {
                                  "re": {
                                    "type": "string"
                                  },
                                  "eq": {
                                    "type": "string"
                                  },
                                  "neq": {
                                    "type": "string"
                                  },
                                  "inc": {
                                    "type": "array",
                                    "items": {
                                      "type": "string"
                                    }
                                  },
                                  "ninc": {
                                    "type": "array",
                                    "items": {
                                      "type": "string"
                                    }
                                  },
                                  "pre": {
                                    "type": "string"
                                  },
                                  "suf": {
                                    "type": "string"
                                  },
                                  "gt": {
                                    "type": "number"
                                  },
                                  "gte": {
                                    "type": "number"
                                  },
                                  "lt": {
                                    "type": "number"
                                  },
                                  "lte": {
                                    "type": "number"
                                  }
                                }
                              }
                            ]
                          }
                        }
                      }
                    },
                    "missing": {
                      "type": "array",
                      "items": {
                        "type": "object",
                        "required": [
                          "type"
                        ],
                        "properties": {
                          "type": {
                            "type": "string",
                            "enum": [
                              "path",
                              "query",
                              "host",
                              "method",
                              "header",
                              "cookie",
                              "ip_address",
                              "protocol",
                              "scheme",
                              "environment",
                              "region",
                              "initial_request_path"
                            ]
                          },
                          "key": {
                            "type": "string"
                          },
                          "value": {
                            "oneOf": [
                              {
                                "type": "string"
                              },
                              {
                                "type": "object",
                                "properties": {
                                  "re": {
                                    "type": "string"
                                  },
                                  "eq": {
                                    "type": "string"
                                  },
                                  "neq": {
                                    "type": "string"
                                  },
                                  "inc": {
                                    "type": "array",
                                    "items": {
                                      "type": "string"
                                    }
                                  },
                                  "ninc": {
                                    "type": "array",
                                    "items": {
                                      "type": "string"
                                    }
                                  },
                                  "pre": {
                                    "type": "string"
                                  },
                                  "suf": {
                                    "type": "string"
                                  },
                                  "gt": {
                                    "type": "number"
                                  },
                                  "gte": {
                                    "type": "number"
                                  },
                                  "lt": {
                                    "type": "number"
                                  },
                                  "lte": {
                                    "type": "number"
                                  }
                                }
                              }
                            ]
                          }
                        }
                      }
                    },
                    "dest": {
                      "type": "string"
                    },
                    "status": {
                      "type": "number"
                    },
                    "handle": {
                      "type": "string",
                      "enum": [
                        "init",
                        "finalize"
                      ]
                    },
                    "mitigate": {
                      "type": "object",
                      "required": [
                        "action",
                        "rule_id"
                      ],
                      "properties": {
                        "action": {
                          "type": "string",
                          "enum": [
                            "log",
                            "deny",
                            "challenge",
                            "bypass",
                            "rate_limit",
                            "redirect"
                          ]
                        },
                        "rule_id": {
                          "type": "string"
                        },
                        "ttl": {
                          "type": "number"
                        },
                        "erl": {
                          "type": "object",
                          "required": [
                            "algo",
                            "keys",
                            "limit",
                            "window"
                          ],
                          "properties": {
                            "algo": {
                              "type": "string",
                              "enum": [
                                "fixed_window",
                                "token_bucket"
                              ]
                            },
                            "window": {
                              "type": "number"
                            },
                            "limit": {
                              "type": "number"
                            },
                            "keys": {
                              "type": "array",
                              "items": {
                                "type": "string"
                              }
                            }
                          }
                        },
                        "log_headers": {
                          "oneOf": [
                            {
                              "type": "array",
                              "items": {
                                "type": "string"
                              }
                            },
                            {
                              "type": "string",
                              "enum": [
                                "*"
                              ]
                            }
                          ]
                        }
                      }
                    }
                  }
                }
              },
              "firewallSeawallEnabled": {
                "type": "boolean",
                "enum": [
                  false,
                  true
                ]
              },
              "ja3Enabled": {
                "type": "boolean",
                "enum": [
                  false,
                  true
                ]
              },
              "ja4Enabled": {
                "type": "boolean",
                "enum": [
                  false,
                  true
                ]
              },
              "firewallBypassIps": {
                "type": "array",
                "items": {
                  "type": "string"
                }
              },
              "managedRules": {
                "type": "object",
                "nullable": true,
                "required": [
                  "ai_bots",
                  "bot_filter",
                  "owasp",
                  "vercel_ruleset"
                ],
                "properties": {
                  "vercel_ruleset": {
                    "type": "object",
                    "required": [
                      "active"
                    ],
                    "properties": {
                      "active": {
                        "type": "boolean",
                        "enum": [
                          false,
                          true
                        ]
                      },
                      "action": {
                        "type": "string",
                        "enum": [
                          "log",
                          "deny",
                          "challenge"
                        ]
                      }
                    }
                  },
                  "bot_filter": {
                    "type": "object",
                    "required": [
                      "active"
                    ],
                    "properties": {
                      "active": {
                        "type": "boolean",
                        "enum": [
                          false,
                          true
                        ]
                      },
                      "action": {
                        "type": "string",
                        "enum": [
                          "log",
                          "deny",
                          "challenge"
                        ]
                      }
                    }
                  },
                  "ai_bots": {
                    "type": "object",
                    "required": [
                      "active"
                    ],
                    "properties": {
                      "active": {
                        "type": "boolean",
                        "enum": [
                          false,
                          true
                        ]
                      },
                      "action": {
                        "type": "string",
                        "enum": [
                          "log",
                          "deny",
                          "challenge"
                        ]
                      }
                    }
                  },
                  "owasp": {
                    "type": "object",
                    "required": [
                      "active"
                    ],
                    "properties": {
                      "active": {
                        "type": "boolean",
                        "enum": [
                          false,
                          true
                        ]
                      },
                      "action": {
                        "type": "string",
                        "enum": [
                          "log",
                          "deny",
                          "challenge"
                        ]
                      }
                    }
                  }
                }
              },
              "botIdEnabled": {
                "type": "boolean",
                "enum": [
                  false,
                  true
                ]
              },
              "requestLogsKey": {
                "type": "array",
                "items": {
                  "type": "string"
                }
              },
              "log_headers": {
                "oneOf": [
                  {
                    "type": "array",
                    "items": {
                      "type": "string"
                    }
                  },
                  {
                    "type": "string",
                    "enum": [
                      "*"
                    ]
                  }
                ]
              },
              "securityPlus": {
                "type": "boolean",
                "enum": [
                  false,
                  true
                ]
              }
            }
          },
          "oidcTokenConfig": {
            "type": "object",
            "properties": {
              "enabled": {
                "type": "boolean",
                "description": "Whether or not to generate OpenID Connect JSON Web Tokens.",
                "enum": [
                  false,
                  true
                ]
              },
              "issuerMode": {
                "type": "string",
                "description": "- team: `https://oidc.vercel.com/[team_slug]` - global: `https://oidc.vercel.com`",
                "enum": [
                  "team",
                  "global"
                ]
              }
            }
          },
          "tier": {
            "type": "string"
          },
          "abuse": {
            "type": "object",
            "required": [
              "history",
              "updatedAt"
            ],
            "properties": {
              "scanner": {
                "type": "string"
              },
              "history": {
                "type": "array",
                "items": {
                  "type": "object",
                  "required": [
                    "at",
                    "by",
                    "byId",
                    "reason",
                    "scanner"
                  ],
                  "properties": {
                    "scanner": {
                      "type": "string"
                    },
                    "reason": {
                      "type": "string"
                    },
                    "by": {
                      "type": "string"
                    },
                    "byId": {
                      "type": "string"
                    },
                    "at": {
                      "type": "number"
                    }
                  }
                }
              },
              "updatedAt": {
                "type": "number"
              },
              "block": {
                "type": "object",
                "required": [
                  "action",
                  "createdAt",
                  "reason",
                  "statusCode"
                ],
                "properties": {
                  "action": {
                    "type": "string",
                    "enum": [
                      "blocked"
                    ]
                  },
                  "reason": {
                    "type": "string"
                  },
                  "statusCode": {
                    "type": "number"
                  },
                  "createdAt": {
                    "type": "number"
                  },
                  "caseId": {
                    "type": "string"
                  },
                  "actor": {
                    "type": "string"
                  },
                  "comment": {
                    "type": "string"
                  },
                  "ineligibleForAppeal": {
                    "type": "boolean",
                    "enum": [
                      false,
                      true
                    ]
                  },
                  "isCascading": {
                    "type": "boolean",
                    "enum": [
                      false,
                      true
                    ]
                  }
                }
              },
              "blockHistory": {
                "type": "array",
                "items": {
                  "oneOf": [
                    {
                      "type": "object",
                      "required": [
                        "action",
                        "createdAt",
                        "reason",
                        "statusCode"
                      ],
                      "properties": {
                        "action": {
                          "type": "string",
                          "enum": [
                            "blocked"
                          ]
                        },
                        "reason": {
                          "type": "string"
                        },
                        "statusCode": {
                          "type": "number"
                        },
                        "createdAt": {
                          "type": "number"
                        },
                        "caseId": {
                          "type": "string"
                        },
                        "actor": {
                          "type": "string"
                        },
                        "comment": {
                          "type": "string"
                        },
                        "ineligibleForAppeal": {
                          "type": "boolean",
                          "enum": [
                            false,
                            true
                          ]
                        },
                        "isCascading": {
                          "type": "boolean",
                          "enum": [
                            false,
                            true
                          ]
                        }
                      }
                    },
                    {
                      "type": "object",
                      "required": [
                        "action",
                        "createdAt"
                      ],
                      "properties": {
                        "action": {
                          "type": "string",
                          "enum": [
                            "unblocked"
                          ]
                        },
                        "createdAt": {
                          "type": "number"
                        },
                        "caseId": {
                          "type": "string"
                        },
                        "actor": {
                          "type": "string"
                        },
                        "comment": {
                          "type": "string"
                        },
                        "ineligibleForAppeal": {
                          "type": "boolean",
                          "enum": [
                            false,
                            true
                          ]
                        },
                        "isCascading": {
                          "type": "boolean",
                          "enum": [
                            false,
                            true
                          ]
                        }
                      }
                    },
                    {
                      "type": "object",
                      "required": [
                        "action",
                        "createdAt",
                        "reason",
                        "route"
                      ],
                      "properties": {
                        "action": {
                          "type": "string",
                          "enum": [
                            "route-blocked"
                          ]
                        },
                        "route": {
                          "oneOf": [
                            {
                              "type": "object",
                              "required": [
                                "src",
                                "status"
                              ],
                              "properties": {
                                "src": {
                                  "type": "string"
                                },
                                "status": {
                                  "type": "number"
                                }
                              }
                            },
                            {
                              "type": "object",
                              "required": [
                                "has",
                                "mitigate"
                              ],
                              "properties": {
                                "has": {
                                  "type": "array",
                                  "items": {
                                    "oneOf": [
                                      {
                                        "type": "object",
                                        "required": [
                                          "key",
                                          "type",
                                          "value"
                                        ],
                                        "properties": {
                                          "type": {
                                            "type": "string",
                                            "enum": [
                                              "header"
                                            ]
                                          },
                                          "key": {
                                            "type": "string",
                                            "enum": [
                                              "x-vercel-ip-country"
                                            ]
                                          },
                                          "value": {
                                            "type": "object",
                                            "required": [
                                              "eq"
                                            ],
                                            "properties": {
                                              "eq": {
                                                "type": "string"
                                              }
                                            }
                                          }
                                        }
                                      },
                                      {
                                        "type": "object",
                                        "required": [
                                          "type",
                                          "value"
                                        ],
                                        "properties": {
                                          "type": {
                                            "type": "string",
                                            "enum": [
                                              "host"
                                            ]
                                          },
                                          "value": {
                                            "type": "object",
                                            "required": [
                                              "eq"
                                            ],
                                            "properties": {
                                              "eq": {
                                                "type": "string"
                                              }
                                            }
                                          }
                                        }
                                      }
                                    ]
                                  }
                                },
                                "mitigate": {
                                  "type": "object",
                                  "required": [
                                    "action"
                                  ],
                                  "properties": {
                                    "action": {
                                      "type": "string",
                                      "enum": [
                                        "block_legal_cwc"
                                      ]
                                    }
                                  }
                                },
                                "src": {
                                  "type": "string"
                                }
                              }
                            }
                          ]
                        },
                        "reason": {
                          "type": "string"
                        },
                        "createdAt": {
                          "type": "number"
                        },
                        "caseId": {
                          "type": "string"
                        },
                        "actor": {
                          "type": "string"
                        },
                        "comment": {
                          "type": "string"
                        },
                        "ineligibleForAppeal": {
                          "type": "boolean",
                          "enum": [
                            false,
                            true
                          ]
                        },
                        "isCascading": {
                          "type": "boolean",
                          "enum": [
                            false,
                            true
                          ]
                        }
                      }
                    },
                    {
                      "type": "object",
                      "required": [
                        "action",
                        "createdAt",
                        "route"
                      ],
                      "properties": {
                        "action": {
                          "type": "string",
                          "enum": [
                            "route-unblocked"
                          ]
                        },
                        "route": {
                          "oneOf": [
                            {
                              "type": "object",
                              "required": [
                                "src",
                                "status"
                              ],
                              "properties": {
                                "src": {
                                  "type": "string"
                                },
                                "status": {
                                  "type": "number"
                                }
                              }
                            },
                            {
                              "type": "object",
                              "required": [
                                "has",
                                "mitigate"
                              ],
                              "properties": {
                                "has": {
                                  "type": "array",
                                  "items": {
                                    "oneOf": [
                                      {
                                        "type": "object",
                                        "required": [
                                          "key",
                                          "type",
                                          "value"
[...]
